## looking-glass 0%2Ba12

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -O3
export DPKG_EXPORT_BUILDFLAGS = 1

include  /usr/share/dpkg/pkg-info.mk
export DEB_VERSION

%:
	dh $@ --sourcedirectory=client

override_dh_install:
	dh_install --sourcedir=client

## looking-glass 0%2Bb1

=== c-host/platform/Windows/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform_Windows LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_library(platform_Windows STATIC
	src/platform.c
	src/windebug.c
	src/mousehook.c
)

add_subdirectory("capture")

FIND_PROGRAM(WINDRES_EXECUTABLE NAMES "x86_64-w64-mingw32-windres" "windres.exe" DOC "windres executable")
ADD_CUSTOM_COMMAND(TARGET platform_Windows POST_BUILD
	WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
	COMMAND ${WINDRES_EXECUTABLE} -i resource.rc -o "${PROJECT_BINARY_DIR}/resource.o"
	VERBATIM
)

target_link_libraries(platform_Windows
	"${PROJECT_BINARY_DIR}/resource.o"
	lg_common
	capture
	setupapi
)

target_include_directories(platform_Windows
	PRIVATE
		src
)

=== client/fonts/SDL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(font_SDL LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(FONT_SDL_PKGCONFIG REQUIRED
	SDL2_ttf
	fontconfig
)

add_library(font_SDL STATIC
	src/sdl.c
)

target_link_libraries(font_SDL
	${FONT_SDL_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(font_SDL
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${FONT_SDL_PKGCONFIG_INCLUDE_DIRS}
)

=== client/renderers/OpenGL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(renderer_Opengl LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(RENDERER_OPENGL_PKGCONFIG REQUIRED
	gl
	glu
)

add_library(renderer_OpenGL STATIC
	opengl.c
)

target_link_libraries(renderer_OpenGL
	${RENDERER_OPENGL_PKGCONFIG_LIBRARIES}
	lg_common
	decoders
	fonts
)

target_include_directories(renderer_OpenGL
	PRIVATE
		src
		${RENDERER_OPENGL_PKGCONFIG_INCLUDE_DIRS}
)

## looking-glass 0%2Bb4%2Bdfsg.1

=== common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(lg_common LANGUAGES C)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_definitions(-D_GNU_SOURCE)

if(ENABLE_BACKTRACE)
  add_definitions(-DENABLE_BACKTRACE)
endif()

if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(
    "-Wno-unknown-warning-option"
  )
endif()

add_subdirectory(src/platform)

set(COMMON_SOURCES
  src/stringutils.c
  src/stringlist.c
  src/option.c
  src/framebuffer.c
  src/KVMFR.c
  src/countedbuffer.c
  src/runningavg.c
)

add_library(lg_common STATIC ${COMMON_SOURCES})
target_link_libraries(lg_common lg_common_platform)

target_include_directories(lg_common
	INTERFACE
		include
	PRIVATE
		src
)

=== client/displayservers/SDL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(displayserver_SDL LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(DISPLAYSERVER_SDL_PKGCONFIG REQUIRED
	sdl2
)

add_library(displayserver_SDL STATIC
	sdl.c
)

target_link_libraries(displayserver_SDL
	${DISPLAYSERVER_SDL_PKGCONFIG_LIBRARIES}
	${DISPLAYSERVER_SDL_OPT_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(displayserver_SDL
	PRIVATE
		src
		${DISPLAYSERVER_SDL_PKGCONFIG_INCLUDE_DIRS}
		${DISPLAYSERVER_SDL_OPT_PKGCONFIG_INCLUDE_DIRS}
)

=== client/fonts/freetype/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(font_freetype LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(FONT_FREETYPE_PKGCONFIG REQUIRED
	freetype2
	fontconfig
)

add_library(font_freetype STATIC
	src/freetype.c
)

target_link_libraries(font_freetype
	${FONT_FREETYPE_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(font_freetype
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${FONT_FREETYPE_PKGCONFIG_INCLUDE_DIRS}
)

=== repos/LGMP/lgmp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(lgmp LANGUAGES C)

include_directories(include)

set(SOURCES
	src/host.c
	src/client.c
	src/status.c
)

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

add_library(lgmp STATIC ${SOURCES})
target_include_directories(lgmp
	INTERFACE
		include
	PRIVATE
		src
)

=== repos/LGMP/test-client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(test-client)

include_directories(include)
set(SOURCES main.c)

get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)
add_subdirectory("${PROJECT_TOP}/lgmp" "${CMAKE_BINARY_DIR}/lgmp")

add_executable(test-client ${SOURCES})
target_link_libraries(test-client
	lgmp
)

=== repos/PureSpice/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
set(TARGET_NAME "spice-test")
project(${TARGET_NAME})

include_directories(include)
set(SOURCES main.c)

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)
add_subdirectory("${PROJECT_TOP}" "${CMAKE_BINARY_DIR}/spice")
add_subdirectory("ADL" "${CMAKE_BINARY_DIR}/ADL")

add_executable(${TARGET_NAME} ${SOURCES})
target_link_libraries(${TARGET_NAME}
	adl
	purespice
)

=== host/platform/Linux/capture/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(capture LANGUAGES C)

include("PreCapture")

add_capture("XCB")

include("PostCapture")

add_library(capture STATIC ${CAPTURE_C})
target_link_libraries(capture ${CAPTURE_LINK})

=== repos/PureSpice/test/ADL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(TARGET_NAME "adl")
project(${TARGET_NAME} LANGUAGES C)
set(CMAKE_C_STANDARD 11)

find_package(PkgConfig)

include_directories(include)
link_libraries(${CMAKE_DL_LIBS})

if(UNIX)
  set(PLATFORM "linux")
  set(PUBLIC_DEFS -D ADL_PLATFORM_LINUX)
  set(PRIVATE_DEFS -D_GNU_SOURCE)
  link_libraries(pthread)
  link_libraries(rt)
elseif(WIN32)
  set(PLATFORM "win32")
  set(PUBLIC_DEFS -D ADL_PLATFORM_WIN32)
  set(PRIVATE_DEFS)
endif(UNIX)

set(SOURCES
  src/adl.c
  src/window.c
  src/image.c
  src/status.c  
  src/logging.c
  src/linkedlist.c
  ${PLATFORM}/util.c
  ${PLATFORM}/thread.c
  ${PLATFORM}/timer.c
)

find_package(OpenGL COMPONENTS EGL)
if (OpenGL_EGL_FOUND)
  list(APPEND PUBLIC_DEFS -DADL_HAS_EGL)
  include_directories(${OPENGL_EGL_INCLUDE_DIRS})
  link_libraries(${OPENGL_egl_LIBRARY})
endif(OpenGL_EGL_FOUND)

pkg_check_modules(XCB
  x11-xcb
  xcb
  xcb-dri3
  xcb-present
  xcb-xkb
  xcb-cursor
  xcb-render
)

if(XCB_FOUND)  
  list(APPEND SOURCES
    linux/xcb/xcb.c
    linux/xcb/image.c)
  include_directories(${XCB_INCLUDE_DIRS})
  link_libraries(${XCB_LIBRARIES})
endif(XCB_FOUND)

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}" ABSOLUTE)
include_directories(${PROJECT_TOP})

add_library(${TARGET_NAME} OBJECT ${SOURCES})
target_compile_definitions(${TARGET_NAME} PRIVATE ${PRIVATE_DEFS} PUBLIC ${PUBLIC_DEFS})
target_include_directories(${TARGET_NAME}
  INTERFACE
    include
  PRIVATE
    src
)

## looking-glass 0%2Bb6

=== host/platform/Linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform_Linux LANGUAGES C)

include_directories(
  ${PROJECT_SOURCE_DIR}/include
)

add_library(platform_Linux STATIC
  src/platform.c
)

add_subdirectory("capture")

target_link_libraries(platform_Linux
  m
  capture
  pthread
)

target_include_directories(platform_Linux
  PRIVATE
    src
)

=== repos/LGMP/lgmp/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
 add_compile_options(
   "-Wall"
   "-Werror"
+  "-Wstrict-prototypes"
   "-Wfatal-errors"
   "-ffast-math"
   "-fdata-sections"

=== host/platform/Windows/capture/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(capture LANGUAGES C)

include(PreCapture)

option(USE_NVFBC "Enable NVFBC Support" OFF)
option(USE_DXGI  "Enable DXGI Support" ON)

if(NOT DEFINED NVFBC_SDK)
  set(NVFBC_SDK "C:/Program Files (x86)/NVIDIA Corporation/NVIDIA Capture SDK")
endif()

file(TO_CMAKE_PATH "${NVFBC_SDK}" nvfbc_sdk)

if(NOT EXISTS "${nvfbc_sdk}/inc" OR NOT IS_DIRECTORY "${nvfbc_sdk}/inc")
  message("Disabling NVFBC support, can't find the SDK headers")
  set(USE_NVFBC OFF)
endif()

if(USE_DXGI)
  add_capture("DXGI")
endif()

if(USE_NVFBC)
  add_capture("NVFBC")
endif()

add_feature_info(USE_DXGI USE_DXGI "DXGI Desktop Duplication capture backend.")
add_feature_info(USE_NVFBC USE_NVFBC "NVFBC capture backend.")

include("PostCapture")

add_library(capture STATIC ${CAPTURE_C})
target_link_libraries(capture ${CAPTURE_LINK})

=== debian/control ===
Source: looking-glass
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders: James Lu <jlu@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-exec,
               fonts-freefont-ttf,
               libfontconfig-dev,
               libobs-dev,
               libpipewire-0.3-dev,
               libpulse-dev,
               libsamplerate0-dev,
               libsdl2-dev,
               libsdl2-ttf-dev,
               libspice-protocol-dev,
               libx11-dev,
               nettle-dev,
               libxpresent-dev,
               wayland-protocols
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://looking-glass.hostfission.com
Vcs-Browser: https://salsa.debian.org/lhw-guest/looking-glass
Vcs-Git: https://salsa.debian.org/lhw-guest/looking-glass.git

Package: looking-glass-client
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: qemu-system-x86, xen-hypervisor
Description: Low latency KVM FrameRelay implementation for VGA Passthrough
 LookingGlass enables you to use shared memory to pass rendered frames from a
 virtual machine back to the host system.
 .
 A LookingGlass Host implementation is required to run on the guest virtual
 machine. It is recommended that the client and host versions match. See the
 README.Debian for more information.

Package: obs-plugin-looking-glass
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: obs-studio
Description: Looking Glass KVM FrameRelay plugin for OBS-Studio
 LookingGlass enables you to use shared memory to pass rendered frames from a
 virtual machine back to the host system.
 .
 This package adds a source plugin for OBS Studio which allows recording the
 looking-glass host session directly from the shared memory.

## looking-glass 0%2Bb7%2Bds1

=== common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(lg_common LANGUAGES C)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include_directories(
  ${PROJECT_SOURCE_DIR}/include
)

add_definitions(-D_GNU_SOURCE)

if(ENABLE_BACKTRACE)
  add_definitions(-DENABLE_BACKTRACE)
endif()

if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(
    "-Wno-unknown-warning-option"
  )
endif()

add_subdirectory(src/platform)

set(COMMON_SOURCES
  src/appstrings.c
  src/stringutils.c
  src/stringlist.c
  src/option.c
  src/framebuffer.c
  src/KVMFR.c
  src/countedbuffer.c
  src/rects.c
  src/runningavg.c
  src/ringbuffer.c
  src/vector.c
  src/cpuinfo.c
  src/debug.c
  src/ll.c
)

add_library(lg_common STATIC ${COMMON_SOURCES})
target_link_libraries(lg_common lg_common_platform)

target_include_directories(lg_common
  INTERFACE
    include
  PRIVATE
    src
)

=== host/platform/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(platform LANGUAGES C)

if (UNIX)
  set(PLATFORM "Linux")
elseif(WIN32)
  set(PLATFORM "Windows")
endif()

add_subdirectory(${PLATFORM})

add_library(platform INTERFACE)
target_link_libraries(platform INTERFACE platform_${PLATFORM})

=== repos/PureSpice/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(purespice LANGUAGES C)
set(CMAKE_C_STANDARD 11)

find_package(PkgConfig)
pkg_check_modules(SPICE_PKGCONFIG REQUIRED
	spice-protocol
	nettle
	hogweed
)

add_definitions(-D USE_NETTLE)

add_compile_options(
  "-Wall"
  "-Wextra"
  "-Werror"
  "-Wfatal-errors"
  "-Wstrict-prototypes"
)
add_library(purespice STATIC
	src/ps.c
	src/log.c
	src/rsa.c
	src/queue.c
	src/channel.c
	src/channel_main.c
	src/channel_inputs.c
	src/channel_playback.c
	src/channel_record.c
	src/channel_display.c
	src/channel_cursor.c
	src/agent.c
)

target_link_libraries(purespice
	${SPICE_PKGCONFIG_LIBRARIES}
	gmp
)

target_include_directories(purespice
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${SPICE_PKGCONFIG_INCLUDE_DIRS}
)

=== client/audiodevs/PipeWire/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(audiodev_PipeWire LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(AUDIODEV_PipeWire REQUIRED IMPORTED_TARGET
  libpipewire-0.3
)

add_library(audiodev_PipeWire STATIC
  pipewire.c
)

target_link_libraries(audiodev_PipeWire
  PkgConfig::AUDIODEV_PipeWire
  lg_common
)

target_include_directories(audiodev_PipeWire
  PRIVATE
    src
)

=== client/renderers/OpenGL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(renderer_Opengl LANGUAGES C CXX)

find_package(PkgConfig)
pkg_check_modules(RENDERER_OPENGL REQUIRED IMPORTED_TARGET
  gl
)

add_library(renderer_OpenGL STATIC
  opengl.c
  ${PROJECT_TOP}/repos/cimgui/imgui/backends/imgui_impl_opengl2.cpp
)

target_compile_definitions(renderer_OpenGL PRIVATE CIMGUI_DEFINE_ENUMS_AND_STRUCTS=1)

target_link_libraries(renderer_OpenGL
  PkgConfig::RENDERER_OPENGL
  lg_common

  cimgui
)

target_include_directories(renderer_OpenGL
  PRIVATE
    src
)

=== repos/LGMP/lgmp/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0.0)
+cmake_minimum_required(VERSION 3.10)
 project(lgmp LANGUAGES C)
 
 include_directories(include)

=== repos/cimgui/backend_test/example_sdl_opengl3/CMakeLists.txt ===
Project(cimgui_sdl)
cmake_minimum_required(VERSION 2.8)
if(WIN32) #to mingw work as all the others
set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif(WIN32)

set (CMAKE_CXX_STANDARD 11)

#general settings


if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../imgui/backends)
	set(BAKENDS_FOLDER "../../imgui/backends/")
else()
	set(BAKENDS_FOLDER "../../imgui/examples/")
endif()

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../imgui/imgui_tables.cpp)
	set(TABLES_SOURCE "../../imgui/imgui_tables.cpp")
else()
	set(TABLES_SOURCE "")
endif()

include_directories(../../imgui)
add_definitions("-DIMGUI_USER_CONFIG=\"../cimconfig.h\"")
add_definitions("-DIMGUI_DISABLE_OBSOLETE_FUNCTIONS=1")

include_directories(../../)
set(IMGUI_SOURCES 
../../cimgui.cpp 
../../imgui/imgui.cpp 
../../imgui/imgui_draw.cpp 
../../imgui/imgui_demo.cpp 
../../imgui/imgui_widgets.cpp
${TABLES_SOURCE} 
)

set(IMGUI_SOURCES_sdl)
set(IMGUI_LIBRARIES )

if (WIN32)
    add_definitions("-DIMGUI_IMPL_API=extern \"C\" __declspec\(dllexport\)")
else(WIN32)
    add_definitions("-DIMGUI_IMPL_API=extern \"C\" ")
endif(WIN32)

add_compile_definitions("IMGUI_IMPL_OPENGL_LOADER_GL3W")

#optional adding freetype
option(IMGUI_FREETYPE "add Freetype2" OFF)

if(IMGUI_FREETYPE)
	FIND_PACKAGE(freetype REQUIRED PATHS ${FREETYPE_PATH})
	list(APPEND IMGUI_LIBRARIES freetype)
	list(APPEND IMGUI_SOURCES ../../imgui/misc/freetype/imgui_freetype.cpp)
	add_definitions("-DCIMGUI_FREETYPE=1")
endif(IMGUI_FREETYPE)

#opengl3
list(APPEND IMGUI_SOURCES ${BAKENDS_FOLDER}imgui_impl_opengl3.cpp)
include_directories(../../imgui/examples/libs/gl3w)
if(WIN32)
       list(APPEND IMGUI_LIBRARIES opengl32)
else(WIN32)#Unix
       list(APPEND IMGUI_LIBRARIES GL)
endif(WIN32)


#sdl2
list(APPEND IMGUI_SOURCES ${BAKENDS_FOLDER}imgui_impl_sdl2.cpp)
if(DEFINED SDL_PATH)
	message(STATUS "SDL_PATH defined as " ${SDL_PATH})
	FIND_PACKAGE(SDL2 PATHS ${SDL_PATH})
else(DEFINED SDL_PATH)
	# If SDL_PATH is not set, fallback and attempt to find SDL cmake script at a default location
	find_package(SDL2)
endif(DEFINED SDL_PATH)

if(SDL2_FOUND)
	get_target_property(SDL_INCLUDE SDL2::SDL2 INTERFACE_INCLUDE_DIRECTORIES)
	message(STATUS "sdlinclude is " ${SDL_INCLUDE})
	if ("${SDL_INCLUDE}" STREQUAL "" OR "${SDL_INCLUDE}" STREQUAL "SDL_INCLUDE-NOTFOUND") #if not found latest SDL2 cmake config use older
		message(STATUS "sdlinclude2 is " ${SDL2_INCLUDE_DIRS})
		include_directories(${SDL2_INCLUDE_DIRS})
		set(IMGUI_SDL_LIBRARY ${SDL2_LIBRARIES})
		message(STATUS IMGUI_SDL_LIBRARY ${SDL2_LIBRARIES})
	else()#use new one SDL2 config
		include_directories(${SDL_INCLUDE})
		set(IMGUI_SDL_LIBRARY SDL2::SDL2)
		set(SDL_MAIN SDL2::SDL2main)
		message(STATUS ${SDL_MAIN} ${IMGUI_SDL_LIBRARY})
	endif()
else(SDL2_FOUND)
	if(DEFINED SDL_PATH)
		message(FATAL_ERROR "Cannot find SDL at SDL_PATH")
	else(DEFINED SDL_PATH)
		message(FATAL_ERROR "Cannot find SDL. Maybe try specifying SDL_PATH?")
	endif(DEFINED SDL_PATH)
endif(SDL2_FOUND)

add_library(cimgui_sdl SHARED ${IMGUI_SOURCES})
target_link_libraries(cimgui_sdl ${IMGUI_LIBRARIES} ${IMGUI_SDL_LIBRARY})

#using library
include_directories(../../generator/output/)
add_executable(test_sdl main.c)
target_compile_definitions(test_sdl PUBLIC -DCIMGUI_USE_OPENGL3 -DCIMGUI_USE_SDL2)
if (MINGW)
target_link_options(test_sdl PRIVATE "-mconsole")
endif()
target_link_libraries(test_sdl ${IMGUI_SDL_LIBRARY} cimgui_sdl)

=== host/platform/Windows/capture/D12/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(capture_D12 LANGUAGES C)

add_library(capture_D12 STATIC
  d12.c
  command_group.c
  backend/dd.c
  effect/rgb24.c
  effect/hdr16to10.c
  effect/downsample.c
)

target_link_libraries(capture_D12
  lg_common
  platform_Windows
  d3d11
  dxgi
  dwmapi
  d3dcompiler
)

target_include_directories(capture_D12
  PRIVATE
    .
    "${PROJECT_TOP}/vendor/directx"
)

=== debian/watch ===
version=4
opts=uversionmangle=s/^(a|B)/\L$1/;s/-/~/g,dversionmangle=s/^0\+(.*?)(\+(dfsg|ds)(\.?\d+)?)?$/$1/,filenamemangle=s@artifact/(.+?)/source@looking-glass-$1\.tar\.gz@,oversionmangle=s/(.*)/0+$1+ds1/ \
  https://looking-glass.io/downloads \
  artifact/([a|B][\d\.]*?\d(?:-rc\d+)?)/source

## looking-glass 0+a12

=== client/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(looking-glass-client C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

SET(CMAKE_C_FLAGS "-std=gnu99 -g -O3 -march=native -Wall -Werror -Wfatal-errors -ffast-math -fdata-sections -ffunction-sections")
SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--gc-sections")

find_package(PkgConfig)
pkg_check_modules(PKGCONFIG REQUIRED
	sdl2
	SDL2_ttf
	gl
	glu
	egl
	spice-protocol
	fontconfig
	x11
	libconfig
	nettle
	hogweed
)

execute_process(
	COMMAND			git describe --always --long --dirty --abbrev=10 --tags
	WORKING_DIRECTORY	${PROJECT_SOURCE_DIR}
	OUTPUT_VARIABLE		BUILD_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

find_package(GMP)

add_definitions(-D BUILD_VERSION='"${BUILD_VERSION}"')
add_definitions(-D USE_NETTLE)
add_definitions(-D ATOMIC_LOCKING)
add_definitions(-D GL_GLEXT_PROTOTYPES)

include_directories(
	${PROJECT_SOURCE_DIR}
	${PROJECT_SOURCE_DIR}/../common
	${PKGCONFIG_INCLUDE_DIRS}
	${GMP_INCLUDE_DIR}
)

link_libraries(
	${PKGCONFIG_LIBRARIES}
	${GMP_LIBRARIES}
	rt m
)

set(SOURCES
	main.c
	lg-renderer.c
	lg-fonts.c
	ll.c
	utils.c
	spice/rsa.c
	spice/spice.c
	decoders/null.c
	decoders/yuv420.c
	renderers/opengl.c
	renderers/egl.c
	renderers/egl/shader.c
	renderers/egl/texture.c
	renderers/egl/model.c
	renderers/egl/desktop.c
	renderers/egl/cursor.c
	renderers/egl/fps.c
	renderers/egl/draw.c
	renderers/egl/splash.c
	renderers/egl/alert.c
	fonts/sdl.c
)

add_executable(looking-glass-client ${SOURCES})
target_compile_options(looking-glass-client PUBLIC ${PKGCONFIG_CFLAGS_OTHER})

=== host/Makefile ===
BINARY  = looking-glass-host.exe
CFLAGS  = -g -O3 -march=native -Wall -Werror -I./ -I../common # -DDEBUG
LDFLAGS = -lshlwapi -ldxgi -ld3d11 -lsetupapi -luuid -lole32 -lmfplat -lmfuuid

CFLAGS  += -ffast-math
CFLAGS  += -fdata-sections -ffunction-sections
CFLAGS  += -I../ -I.
LDFLAGS += -Wl,--gc-sections -mwindows
CFLAGS  += -DWINVER=0x0602 -DUNICODE

PREFIX ?= x86_64-w64-mingw32-
STRIP  = $(PREFIX)strip
CC     = $(PREFIX)cc
CXX    = $(PREFIX)c++
LD     = $(CXX)

BUILD  ?= .build
BIN    ?= bin

CFLAGS  += -DBUILD_VERSION='"$(shell git describe --always --long --dirty --abbrev=10 --tags)"'

OBJS	= main.o \
	  CrashHandler.o \
	  MultiMemcpy.o \
	  IVSHMEM.o \
	  Service.o \
	  Capture/DXGI.o

ifeq ($(ENABLE_TRACING),1)
CFLAGS  += -DENABLE_TRACING
OBJS    += TraceUtil.o
endif

ifeq ($(CONFIG_CAPTURE_NVFBC),1)
CFLAGS  += -DCONFIG_CAPTURE_NVFBC=1 -I../vendor
OBJS    += Capture/NvFBC.o
endif

BUILD_OBJS = $(foreach obj,$(OBJS),$(BUILD)/$(obj))

all: $(BIN)/$(BINARY)

$(BUILD)/%.o: %.c
	@mkdir -p $(dir $@)
	$(CC) -c $(CFLAGS) -o $@ $<

$(BUILD)/%.o: %.cpp
	@mkdir -p $(dir $@)
	$(CXX) -c $(CFLAGS) -o $@ $<

$(BIN)/$(BINARY): $(BUILD_OBJS)
	@mkdir -p $(dir $@)
	$(LD) -o $@ $^ $(LDFLAGS)
	$(STRIP) -s $@

clean:
	rm -rf $(BUILD) $(BIN)

.PHONY: clean

=== module/Makefile ===
obj-m += kvmfr.o
USER  := $(shell whoami)

all:
	make -C /lib/modules/$(shell uname -r)/build/ M=$(PWD) modules

clean:
	make -C /lib/modules/$(shell uname -r)/build/ M=$(PWD) clean

test:	all
	grep -q '^uio'   /proc/modules || sudo modprobe uio
	grep -q '^kvmfr' /proc/modules && sudo rmmod kvmfr || true
	sudo insmod ./kvmfr.ko
	sudo chown $(USER) /dev/uio0
	../client/bin/looking-glass-client -f /dev/uio0 -L 128

=== debian/changelog ===
looking-glass (0+a12-2) unstable; urgency=medium

  * Remove shared memory file on purge
  * Updated Standards-Version to 4.3.0

 -- Lennart Weller <lhw@ring0.de>  Tue, 29 Jan 2019 12:05:10 +0100

looking-glass (0+a12-1) unstable; urgency=medium

  * Initial release. (Closes: #898931)

 -- Lennart Weller <lhw@ring0.de>  Fri, 25 Jan 2019 00:21:48 +0100

=== debian/control ===
Source: looking-glass
Section: net
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Build-Depends: cmake,
               debhelper (>= 11~),
               libconfig-dev,
               libfontconfig-dev,
               libsdl2-ttf-dev,
               libspice-protocol-dev,
               nettle-dev
Standards-Version: 4.3.0
Homepage: https://github.com/gnif/LookingGlass/
Vcs-Browser: https://salsa.debian.org/lhw-guest/looking-glass
Vcs-Git: https://salsa.debian.org/lhw-guest/looking-glass.git

Package: looking-glass-client
Architecture: amd64
Depends: ${misc:Depends}, ${misc:Pre-Depends}, ${shlibs:Depends}
Enhances: qemu, qemu-kvm, xen
Description: Low latency KVM FrameRelay implementation for VGA Passthrough
 LookingGlass enables you to use shared memory to pass rendered frames from a
 virtual machine back to the host system.
 .
 A LookingGlass Host implementation is required to run on the guest virtual
 machine. It is recommended that the client and host versions match. See the
 README.Debian for more information.

=== debian/watch ===
version=3
opts=dversionmangle=s/0\+a//,filenamemangle=s/.+\/a(\d\S*)\.tar\.gz/looking-glass-a$1\.tar\.gz/ \
	https://github.com/gnif/LookingGlass/releases .*/a(\d\S*)\.tar\.gz

## looking-glass 0+b1

=== c-host/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(looking-glass-host C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" ON)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
endif()

option(ENABLE_BACKTRACE "Enable backtrace support on crash" ON)
add_feature_info(ENABLE_BACKTRACE ENABLE_BACKTRACE "Backtrace support.")

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)
set(CMAKE_C_STANDARD  11)

execute_process(
	COMMAND			cat ../VERSION
	WORKING_DIRECTORY	${PROJECT_SOURCE_DIR}
	OUTPUT_VARIABLE		BUILD_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_definitions(-D BUILD_VERSION='"${BUILD_VERSION}"')
get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
        ${PROJECT_TOP}/vendor/ivshmem
	${PKGCONFIG_INCLUDE_DIRS}
	${GMP_INCLUDE_DIR}
)

#link_libraries(
#)

set(SOURCES
	src/app.c
)

add_subdirectory("${PROJECT_TOP}/common" "${CMAKE_BINARY_DIR}/common")
add_subdirectory(platform)

if(WIN32)
  add_executable(looking-glass-host WIN32 ${SOURCES})
else()
  add_executable(looking-glass-host ${SOURCES})
endif()
target_link_libraries(looking-glass-host
	lg_common
	platform
)
set_target_properties(looking-glass-host PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-host DESTINATION bin/ COMPONENT binary)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(looking-glass-client C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" ON)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
endif()

option(ENABLE_OPENGL "Enable the OpenGL renderer"       ON)
add_feature_info(ENABLE_OPENGL ENABLE_OPENGL "Legacy OpenGL renderer.")

option(ENABLE_EGL    "Enable the EGL renderer"          ON)
add_feature_info(ENABLE_EGL ENABLE_EGL "EGL renderer.")

option(ENABLE_CB_X11 "Enable X11 clipboard integration" ON)
add_feature_info(ENABLE_CB_X11 ENABLE_CB_X11 "X11 Clipboard Integration.")

option(ENABLE_BACKTRACE "Enable backtrace support on crash" ON)
add_feature_info(ENABLE_BACKTRACE ENABLE_BACKTRACE "Backtrace support.")

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

set(EXE_FLAGS "-Wl,--gc-sections")
set(CMAKE_C_STANDARD 11)

find_package(PkgConfig)
pkg_check_modules(PKGCONFIG REQUIRED
	sdl2
	x11
)

execute_process(
	COMMAND			cat ../VERSION
	WORKING_DIRECTORY	${PROJECT_SOURCE_DIR}
	OUTPUT_VARIABLE		BUILD_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

find_package(GMP)

add_definitions(-D BUILD_VERSION='"${BUILD_VERSION}"')
add_definitions(-D ATOMIC_LOCKING)
add_definitions(-D GL_GLEXT_PROTOTYPES)
get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
	${PKGCONFIG_INCLUDE_DIRS}
	${GMP_INCLUDE_DIR}
)

link_libraries(
	${PKGCONFIG_LIBRARIES}
	${GMP_LIBRARIES}
	rt
	m
)

set(SOURCES
	src/main.c
	src/app.c
	src/config.c
	src/lg-renderer.c
	src/ll.c
	src/utils.c
)

add_subdirectory("${PROJECT_TOP}/common" "${CMAKE_BINARY_DIR}/common")
add_subdirectory(spice)
add_subdirectory(renderers)
add_subdirectory(clipboards)
add_subdirectory(fonts)
add_subdirectory(decoders)

add_executable(looking-glass-client ${SOURCES})
target_compile_options(looking-glass-client PUBLIC ${PKGCONFIG_CFLAGS_OTHER})
target_link_libraries(looking-glass-client
	${EXE_FLAGS}
	lg_common
	spice
	renderers
	clipboards
	fonts
)

install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-client DESTINATION bin/ COMPONENT binary)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(lg_common LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

if(ENABLE_BACKTRACE)
  add_definitions(-DENABLE_BACKTRACE)
endif()

set(COMMON_SOURCES
  src/stringutils.c
  src/stringlist.c
  src/option.c
)

set(LINUX_SOURCES
  src/crash.linux.c
  src/sysinfo.linux.c
)

set(WINDOWS_SOURCES
  src/crash.windows.c
  src/sysinfo.windows.c
)

if(WIN32)
  set(SOURCES ${COMMON_SOURCES} ${WINDOWS_SOURCES})
  add_library(lg_common STATIC ${SOURCES})
else()
  set(SOURCES ${COMMON_SOURCES} ${LINUX_SOURCES})
  add_library(lg_common STATIC ${SOURCES})
  if(ENABLE_BACKTRACE)
    target_link_libraries(lg_common bfd)
  endif()
endif()

target_include_directories(lg_common
	INTERFACE
		include
	PRIVATE
		src
)

=== module/Makefile ===
obj-m += kvmfr.o
USER  := $(shell whoami)
KVER ?= $(shell uname -r)
KDIR ?= /lib/modules/$(KVER)/build

all:
	make -C $(KDIR) M=$(PWD) modules

clean:
	make -C $(KDIR) M=$(PWD) clean

test:	all
	grep -q '^uio'   /proc/modules || sudo modprobe uio
	grep -q '^kvmfr' /proc/modules && sudo rmmod kvmfr || true
	sudo insmod ./kvmfr.ko
	sudo chown $(USER) /dev/uio0

=== client/clipboards/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(clipboards LANGUAGES C)

set(CLIPBOARD_H "${CMAKE_BINARY_DIR}/include/dynamic/clipboards.h")
set(CLIPBOARD_C "${CMAKE_BINARY_DIR}/src/clipboards.c")

file(WRITE  ${CLIPBOARD_H} "#include \"interface/clipboard.h\"\n\n")
file(APPEND ${CLIPBOARD_H} "extern LG_Clipboard * LG_Clipboards[];\n\n")

file(WRITE  ${CLIPBOARD_C} "#include \"interface/clipboard.h\"\n\n")
file(APPEND ${CLIPBOARD_C} "#include <stddef.h>\n\n")

set(CLIPBOARDS "_")
set(CLIPBOARDS_LINK "_")
function(add_clipboard name)
  set(CLIPBOARDS      "${CLIPBOARDS};${name}" PARENT_SCOPE)
  set(CLIPBOARDS_LINK "${CLIPBOARDS_LINK};clipboard_${name}" PARENT_SCOPE)
  add_subdirectory(${name})
endfunction()

# Add/remove clipboards here!
if (ENABLE_CB_X11)
  add_clipboard(X11)
endif()

list(REMOVE_AT CLIPBOARDS      0)
list(REMOVE_AT CLIPBOARDS_LINK 0)

list(LENGTH CLIPBOARDS CLIPBOARD_COUNT)
file(APPEND ${CLIPBOARD_H} "#define LG_CLIPBOARD_COUNT ${CLIPBOARD_COUNT}\n")

foreach(clipboard ${CLIPBOARDS})
  file(APPEND ${CLIPBOARD_C} "extern LG_Clipboard LGC_${clipboard};\n")
endforeach()

file(APPEND ${CLIPBOARD_C} "\nconst LG_Clipboard * LG_Clipboards[] =\n{\n")
foreach(clipboard ${CLIPBOARDS})
  file(APPEND ${CLIPBOARD_C} "  &LGC_${clipboard},\n")
endforeach()
file(APPEND ${CLIPBOARD_C} "  NULL\n};\n\n")

add_library(clipboards STATIC ${CLIPBOARD_C})
target_link_libraries(clipboards ${CLIPBOARDS_LINK})

=== client/decoders/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(decoders LANGUAGES C)

#find_package(PkgConfig)
#pkg_check_modules(DECODERS_PKGCONFIG REQUIRED
#)

add_library(decoders STATIC
	src/null.c
	src/yuv420.c
)

target_link_libraries(decoders
	lg_common
	${DECODERS_PKGCONFIG_LIBRARIES}
)

target_include_directories(decoders
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${DECODERS_PKGCONFIG_INCLUDE_DIRS}
)

=== client/fonts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(fonts LANGUAGES C)

set(FONT_H "${CMAKE_BINARY_DIR}/include/dynamic/fonts.h")
set(FONT_C "${CMAKE_BINARY_DIR}/src/fonts.c")

file(WRITE  ${FONT_H} "#include \"interface/font.h\"\n\n")
file(APPEND ${FONT_H} "extern LG_Font * LG_Fonts[];\n\n")

file(WRITE  ${FONT_C} "#include \"interface/font.h\"\n\n")
file(APPEND ${FONT_C} "#include <stddef.h>\n\n")

set(FONTS "_")
set(FONTS_LINK "_")
function(add_font name)
  set(FONTS      "${FONTS};${name}" PARENT_SCOPE)
  set(FONTS_LINK "${FONTS_LINK};font_${name}" PARENT_SCOPE)
  add_subdirectory(${name})
endfunction()

# Add/remove fonts here!
add_font(SDL)

list(REMOVE_AT FONTS      0)
list(REMOVE_AT FONTS_LINK 0)

list(LENGTH FONTS FONT_COUNT)
file(APPEND ${FONT_H} "#define LG_FONT_COUNT ${FONT_COUNT}\n")

foreach(font ${FONTS})
  file(APPEND ${FONT_C} "extern LG_Font LGF_${font};\n")
endforeach()

file(APPEND ${FONT_C} "\nconst LG_Font * LG_Fonts[] =\n{\n")
foreach(font ${FONTS})
  file(APPEND ${FONT_C} "  &LGF_${font},\n")
endforeach()
file(APPEND ${FONT_C} "  NULL\n};\n\n")

add_library(fonts STATIC ${FONT_C})
target_link_libraries(fonts ${FONTS_LINK})

=== client/renderers/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(renderers LANGUAGES C)

set(RENDERER_H "${CMAKE_BINARY_DIR}/include/dynamic/renderers.h")
set(RENDERER_C "${CMAKE_BINARY_DIR}/src/renderers.c")

file(WRITE  ${RENDERER_H} "#include \"interface/renderer.h\"\n\n")
file(APPEND ${RENDERER_H} "extern LG_Renderer * LG_Renderers[];\n\n")

file(WRITE  ${RENDERER_C} "#include \"interface/renderer.h\"\n\n")
file(APPEND ${RENDERER_C} "#include <stddef.h>\n\n")

set(RENDERERS "_")
set(RENDERERS_LINK "_")
function(add_renderer name)
  set(RENDERERS      "${RENDERERS};${name}" PARENT_SCOPE)
  set(RENDERERS_LINK "${RENDERERS_LINK};renderer_${name}" PARENT_SCOPE)
  add_subdirectory(${name})
endfunction()

# Add/remove renderers here!
if(ENABLE_EGL)
  add_renderer(EGL)
endif()
if (ENABLE_OPENGL)
  add_renderer(OpenGL)
endif()

list(REMOVE_AT RENDERERS      0)
list(REMOVE_AT RENDERERS_LINK 0)

list(LENGTH RENDERERS RENDERER_COUNT)
file(APPEND ${RENDERER_H} "#define LG_RENDERER_COUNT ${RENDERER_COUNT}\n")

foreach(renderer ${RENDERERS})
  file(APPEND ${RENDERER_C} "extern LG_Renderer LGR_${renderer};\n")
endforeach()

file(APPEND ${RENDERER_C} "\nconst LG_Renderer * LG_Renderers[] =\n{\n")
foreach(renderer ${RENDERERS})
  file(APPEND ${RENDERER_C} "  &LGR_${renderer},\n")
endforeach()
file(APPEND ${RENDERER_C} "  NULL\n};")

add_library(renderers STATIC ${RENDERER_C})
target_link_libraries(renderers ${RENDERERS_LINK})

=== client/spice/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(spice LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(SPICE_PKGCONFIG REQUIRED
	spice-protocol
	nettle
	hogweed
)

add_definitions(-D USE_NETTLE)

add_library(spice STATIC
	src/spice.c
	src/rsa.c
)

target_link_libraries(spice
	lg_common
	${SPICE_PKGCONFIG_LIBRARIES}
)

target_include_directories(spice
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${SPICE_PKGCONFIG_INCLUDE_DIRS}
)

=== c-host/platform/Linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform_Linux LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_library(platform_Linux STATIC
	src/platform.c
)

add_subdirectory("capture")

target_link_libraries(platform_Linux
	capture
	pthread
)

target_include_directories(platform_Linux
	PRIVATE
		src
)

=== client/clipboards/X11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(clipboard_X11 LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(CLIPBOARD_PKGCONFIG REQUIRED
	x11
	xfixes
)

add_library(clipboard_X11 STATIC
	src/x11.c
)

target_link_libraries(clipboard_X11
	${CLIPBOARD_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(clipboard_X11
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${CLIPBOARD_PKGCONFIG_INCLUDE_DIRS}
)

=== client/renderers/EGL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(renderer_EGL LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(RENDERER_EGL_PKGCONFIG REQUIRED
	egl
	wayland-egl
	gl
)

include(MakeObject)
make_object(
	EGL_SHADER
	shader/desktop.vert
	shader/desktop_rgb.frag
	shader/desktop_yuv.frag
	shader/cursor.vert
	shader/cursor_rgb.frag
	shader/cursor_mono.frag
	shader/fps.vert
	shader/fps.frag
	shader/fps_bg.frag
	shader/alert.vert
	shader/alert.frag
	shader/alert_bg.frag
	shader/splash_bg.vert
	shader/splash_bg.frag
	shader/splash_logo.vert
	shader/splash_logo.frag
)

add_library(renderer_EGL STATIC
	egl.c
	shader.c
	texture.c
	model.c
	desktop.c
	cursor.c
	fps.c
	draw.c
	splash.c
	alert.c
	${EGL_SHADER_OBJS}
)

target_link_libraries(renderer_EGL
	${RENDERER_EGL_PKGCONFIG_LIBRARIES}
	lg_common
	fonts
)

target_include_directories(renderer_EGL
	PRIVATE
		src
		${EGL_SHADER_INCS}
		${RENDERER_EGL_PKGCONFIG_INCLUDE_DIRS}
)

=== debian/changelog ===
looking-glass (0+b1-5) unstable; urgency=low

  * Remove global qemu from enhances (Closes: #966260)
  * Specifically enhance qemu-system-x86
  * Make the dh linter happier

 -- Lennart Weller <lhw@ring0.de>  Sat, 25 Jul 2020 21:09:52 +0200

looking-glass (0+b1-4) unstable; urgency=low

  * Re-add upstream version to the version output

 -- Lennart Weller <lhw@ring0.de>  Wed, 29 Apr 2020 22:11:43 +0200

looking-glass (0+b1-3) unstable; urgency=medium

  * Remove backtrace support for now. Solving the binutils issue
  * Also remove potential bad optimizations

 -- Lennart Weller <lhw@ring0.de>  Thu, 16 Jan 2020 20:19:57 +0100

looking-glass (0+b1-2) unstable; urgency=medium

  * Fix FTBFS Bug with binutils 2.33 (Closes: #948529)

 -- Lennart Weller <lhw@ring0.de>  Mon, 13 Jan 2020 00:31:47 +0100

looking-glass (0+b1-1) unstable; urgency=medium

  * New upstream release

 -- Lennart Weller <lhw@ring0.de>  Mon, 22 Jul 2019 20:27:53 +0200

=== debian/control ===
Source: looking-glass
Section: net
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Build-Depends: cmake,
               debhelper (>= 12),
               debhelper-compat (= 12),
               libconfig-dev,
               libfontconfig-dev,
               libsdl2-ttf-dev,
               libspice-protocol-dev,
               nettle-dev
Standards-Version: 4.5.0
Homepage: https://looking-glass.hostfission.com
Vcs-Browser: https://salsa.debian.org/lhw-guest/looking-glass
Vcs-Git: https://salsa.debian.org/lhw-guest/looking-glass.git

Package: looking-glass-client
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends} 
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: qemu-system-x86, xen-hypervisor
Description: Low latency KVM FrameRelay implementation for VGA Passthrough
 LookingGlass enables you to use shared memory to pass rendered frames from a
 virtual machine back to the host system.
 .
 A LookingGlass Host implementation is required to run on the guest virtual
 machine. It is recommended that the client and host versions match. See the
 README.Debian for more information.

=== debian/rules ===
--- 
+++ 
@@ -12,5 +12,8 @@
 %:
 	dh $@ --sourcedirectory=client
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DOPTIMIZE_FOR_NATIVE=OFF -DENABLE_BACKTRACE=OFF
+
 override_dh_install:
 	dh_install --sourcedir=client

=== debian/watch ===
version=3
opts=dversionmangle=s/0\+//,filenamemangle=s/.+\/(a|B)(\d\S*)\.tar\.gz/looking-glass-$1$2\.tar\.gz/ \
	https://github.com/gnif/LookingGlass/releases .*/(a|B)(\d\S*)\.tar\.gz
